﻿using Infragistics.Shared;
using Infragistics.Win;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WG_TimeColumn
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            SetUpGridDataSource();

            this.ultraDateTimeEditor1.MaskInput = "{time}";
            this.ultraDateTimeEditor1.DropDownButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Never;
            this.ultraDateTimeEditor1.SpinButtonDisplayStyle = Infragistics.Win.ButtonDisplayStyle.Always;
            this.ultraDateTimeEditor1.Visible = false;
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["Time"].Style = Infragistics.Win.UltraWinGrid.ColumnStyle.Time;
            e.Layout.Bands[0].Columns["Time"].EditorComponent = this.ultraDateTimeEditor1;
            var editor = (EditorWithMask)e.Layout.Bands[0].Columns["Time"].Editor;
            var increment = new DateTimeIncrement();
            increment.Hours = 1;
            editor.SpinIncrement = increment;
            editor.SpinWrap = true;
        }

        private void SetUpGridDataSource()
        {
            DataSet ds = new DataSet();
            DataTable t1 = ds.Tables.Add("table1");
            t1.Columns.Add("id", typeof(int)).AutoIncrement = true;
            t1.Columns.Add("Name", typeof(string));
            t1.Columns.Add("Quantity", typeof(int));
            t1.Columns.Add("Price", typeof(decimal));
            t1.Columns.Add("Time", typeof(DateTime));

            ds.Tables["table1"].Rows.Add(new Object[] { null, "Beverage", 50, 10.2, DateTime.Today.AddHours(4)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Appliances", 5, 90.4, DateTime.Today.AddHours(5)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "FastFood", 20, 34.2, DateTime.Today.AddHours(3)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Furniture", 12, 79.1, DateTime.Today.AddHours(12)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Meat", 40, 10.2, DateTime.Today.AddHours(15)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Fruits", 25, 12.32, DateTime.Today.AddHours(17)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Vegetables", 30, 13.5, DateTime.Today.AddHours(4)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Cars", 13, 200.3, DateTime.Today.AddHours(7)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Tools", 60, 15.3, DateTime.Today.AddHours(8)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Estate", 5, 3000, DateTime.Today.AddHours(22)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Motorcycles", 10, 320 ,DateTime.Today.AddHours(12)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Clothes", 40, 69.3, DateTime.Today.AddHours(4)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Shoes", 24, 40.6, DateTime.Today.AddHours(1)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Games", 53, 50.32, DateTime.Today.AddHours(5)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Books", 42, 22.12, DateTime.Today.AddHours(21)});
            ds.Tables["table1"].Rows.Add(new Object[] { null, "Movies", 38, 19.43, DateTime.Today.AddHours(10) });

            ultraGrid1.DataSource = ds;
        }

    }
}
